# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_study
# FileName:      db.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 11:09
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import pymysql

from InterfaceAutoTest.common import log
from InterfaceAutoTest.common.read_ini import ReadIni
from InterfaceAutoTest.data_config.settings import *

class DB:
    def __init__(self):
        read_ini = ReadIni()
        try:
            self.conn = pymysql.connect(
                host=read_ini.get_sql_mess(HOST),
                port=int(read_ini.get_sql_mess(PORT)),
                user=read_ini.get_sql_mess(USER),
                password=read_ini.get_sql_mess(PWD),
                database=read_ini.get_sql_mess(DATABASE),
                charset="utf8"
            )
            self.cursor = self.conn.cursor()
        except:
            log.error("链接数据库错误或者获取游标对象失败，请察看数据库的链接配置！！！")
            raise pymysql.MySQLError("链接数据库错误或者获取游标对象失败，请察看数据库的链接配置！！！")

    def close(self):
        self.cursor.close()
        self.conn.close()

    def delete(self, sql):
        try:
            self.cursor.execute(sql)
            self.conn.commit()
        except:
            log.error("执行删除的sql语句错误，请察看对应的删除的sql语句！！！")
            raise ValueError("执行删除的sql语句错误，请察看对应的删除的sql语句！！！")

    def select(self, sql, num=1):
        try:
            self.cursor.execute(sql)
            select_result = self.cursor.fetchall()
            if select_result and num == 1:
                return select_result[0][0]
            elif select_result and num == 2:
                return select_result[0][0], select_result[0][1]
            elif select_result and num > 2:
                return select_result
        except:
            log.error("执行查询的sql语句错误，请察看对应的查询的sql语句！！！")
            raise ValueError("执行查询的sql语句错误，请察看对应的查询的sql语句！！！")