# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_study
# FileName:      read_json.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 11:09
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import json
import os

from InterfaceAutoTest.common import log


def read_json(filename):
    if os.path.isfile(filename) and filename.endswith(".json"):
        try:
            with open(filename, mode="r", encoding="utf-8") as f:
                return json.load(f)
        except:
            log.error("打开json文件获取json文件的内容序列化为python对象失败，请察看json文件是否有错误！！！")
            raise FileExistsError("打开json文件获取json文件的内容序列化为python对象失败，请察看json文件是否有错误！！！")
    else:
        log.error("json文件的路径不合法")
        raise FileNotFoundError("json文件的路径不合法")