# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_study
# FileName:      requests_method.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 14:09
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import base64
import requests

from InterfaceAutoTest.common import log
from InterfaceAutoTest.common.read_ini import ReadIni
from InterfaceAutoTest.data_config.settings import *


class RequestsMethod:
    def __init__(self):
        login_url = ReadIni().get_host(URL_HOST_CUSTOM) + "/auth"
        login_data = {"username": "admin", "password": base64.b64encode("123456".encode()).decode()}
        self.bpm_session = requests.sessions.Session()
        self.bpm_session.headers.update({"Authorization": "Bearer "+self.bpm_session.request(method="post", url=login_url, json=login_data).json().get("token")})

    def request_all(self, req_method, req_url, req_mime=None, case_data=None):
        if req_mime == "json" or req_mime == "application/json":
            return self.bpm_session.request(method=req_method, url=req_url, json=case_data)

        elif req_mime == "x-www-form-urlencoded" or req_mime == "application/x-www-form-urlencoded" or req_mime == "body":
            return self.bpm_session.request(method=req_method, url=req_url, data=case_data)

        elif req_mime == "form-data" or req_mime == "multipart/form-data":
            return self.bpm_session.request(method=req_method, url=req_url, files=case_data)

        elif req_mime == "query" or req_mime == "param" or req_mime == "params":
            return self.bpm_session.request(method=req_method, url=req_url, params=case_data)

        elif req_mime is None:
            return self.bpm_session.request(method=req_method, url=req_url)

        elif req_mime == "query|body" or req_mime == "body|query" or req_mime == "query|json":
            return self.bpm_session.request(method=req_method, url=req_url, params=case_data["query"], json=case_data["body"])

        else:
            log.error("传入的媒体类型的值错误，请察看excel中是否填入正确！！！")
            raise NameError("传入的媒体类型的值错误，请察看excel中是否填入正确！！！")


