# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_study
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 14:30
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import pytest

from InterfaceAutoTest.common import log
from InterfaceAutoTest.common.read_excel import ReadExcel
from InterfaceAutoTest.common.read_ini import ReadIni


class TestBPM:

    @pytest.mark.parametrize("case_method, case_url, case_mime, case_data, expect_data, sql_type, sql_data, update_key", ReadExcel("组织").get_data())
    def test_bpm(self, db_fix, req_fix, case_method, case_url, case_mime, case_data, expect_data, sql_type, sql_data, update_key):
        if sql_type == "delete":
            db_fix.delete(sql_data)
        elif sql_type == "select":
            select_result = db_fix.select(sql_data)
            case_data[update_key] = select_result
        elif sql_type == "select|delete" or sql_type == "delete|select":
            db_fix.delete(sql_data.get("delete"))
            select_result = db_fix.select(sql_data.get("select"))
            case_data[update_key] = select_result

        res = req_fix.request_all(req_method=case_method, req_url=case_url, req_mime=case_mime, case_data=case_data)

        try:
            for key in expect_data:
                assert expect_data[key] == res.json().get(key)
        except:
            log.error("断言失败" + "，用例数据为：" + str(case_data) + ",期望数据为：" + str(expect_data) + ",服务器返回的数据为：" + res.text)
            raise AssertionError("断言失败")


if __name__ == '__main__':
    pytest.main()